/*******************************************************************************
* File Name: Pin_3_sw.h  
* Version 1.50
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_Pin_3_sw_H) /* Pins Pin_3_sw_H */
#define CY_PINS_Pin_3_sw_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Pin_3_sw_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    Pin_3_sw_Write(uint8 value) ;
void    Pin_3_sw_SetDriveMode(uint8 mode) ;
uint8   Pin_3_sw_ReadDataReg(void) ;
uint8   Pin_3_sw_Read(void) ;
uint8   Pin_3_sw_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Pin_3_sw_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define Pin_3_sw_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define Pin_3_sw_DM_RES_UP          PIN_DM_RES_UP
#define Pin_3_sw_DM_RES_DWN         PIN_DM_RES_DWN
#define Pin_3_sw_DM_OD_LO           PIN_DM_OD_LO
#define Pin_3_sw_DM_OD_HI           PIN_DM_OD_HI
#define Pin_3_sw_DM_STRONG          PIN_DM_STRONG
#define Pin_3_sw_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define Pin_3_sw_MASK               Pin_3_sw__MASK
#define Pin_3_sw_SHIFT              Pin_3_sw__SHIFT
#define Pin_3_sw_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Pin_3_sw_PS                     (* (reg8 *) Pin_3_sw__PS)
/* Data Register */
#define Pin_3_sw_DR                     (* (reg8 *) Pin_3_sw__DR)
/* Port Number */
#define Pin_3_sw_PRT_NUM                (* (reg8 *) Pin_3_sw__PRT) 
/* Connect to Analog Globals */                                                  
#define Pin_3_sw_AG                     (* (reg8 *) Pin_3_sw__AG)                       
/* Analog MUX bux enable */
#define Pin_3_sw_AMUX                   (* (reg8 *) Pin_3_sw__AMUX) 
/* Bidirectional Enable */                                                        
#define Pin_3_sw_BIE                    (* (reg8 *) Pin_3_sw__BIE)
/* Bit-mask for Aliased Register Access */
#define Pin_3_sw_BIT_MASK               (* (reg8 *) Pin_3_sw__BIT_MASK)
/* Bypass Enable */
#define Pin_3_sw_BYP                    (* (reg8 *) Pin_3_sw__BYP)
/* Port wide control signals */                                                   
#define Pin_3_sw_CTL                    (* (reg8 *) Pin_3_sw__CTL)
/* Drive Modes */
#define Pin_3_sw_DM0                    (* (reg8 *) Pin_3_sw__DM0) 
#define Pin_3_sw_DM1                    (* (reg8 *) Pin_3_sw__DM1)
#define Pin_3_sw_DM2                    (* (reg8 *) Pin_3_sw__DM2) 
/* Input Buffer Disable Override */
#define Pin_3_sw_INP_DIS                (* (reg8 *) Pin_3_sw__INP_DIS)
/* LCD Common or Segment Drive */
#define Pin_3_sw_LCD_COM_SEG            (* (reg8 *) Pin_3_sw__LCD_COM_SEG)
/* Enable Segment LCD */
#define Pin_3_sw_LCD_EN                 (* (reg8 *) Pin_3_sw__LCD_EN)
/* Slew Rate Control */
#define Pin_3_sw_SLW                    (* (reg8 *) Pin_3_sw__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Pin_3_sw_PRTDSI__CAPS_SEL       (* (reg8 *) Pin_3_sw__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Pin_3_sw_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Pin_3_sw__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Pin_3_sw_PRTDSI__OE_SEL0        (* (reg8 *) Pin_3_sw__PRTDSI__OE_SEL0) 
#define Pin_3_sw_PRTDSI__OE_SEL1        (* (reg8 *) Pin_3_sw__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Pin_3_sw_PRTDSI__OUT_SEL0       (* (reg8 *) Pin_3_sw__PRTDSI__OUT_SEL0) 
#define Pin_3_sw_PRTDSI__OUT_SEL1       (* (reg8 *) Pin_3_sw__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Pin_3_sw_PRTDSI__SYNC_OUT       (* (reg8 *) Pin_3_sw__PRTDSI__SYNC_OUT) 


#if defined(Pin_3_sw__INTSTAT)  /* Interrupt Registers */

    #define Pin_3_sw_INTSTAT                (* (reg8 *) Pin_3_sw__INTSTAT)
    #define Pin_3_sw_SNAP                   (* (reg8 *) Pin_3_sw__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins Pin_3_sw_H */


/* [] END OF FILE */
