/*******************************************************************************
* File Name: VDD_en.h  
* Version 1.50
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_VDD_en_H) /* Pins VDD_en_H */
#define CY_PINS_VDD_en_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "VDD_en_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    VDD_en_Write(uint8 value) ;
void    VDD_en_SetDriveMode(uint8 mode) ;
uint8   VDD_en_ReadDataReg(void) ;
uint8   VDD_en_Read(void) ;
uint8   VDD_en_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define VDD_en_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define VDD_en_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define VDD_en_DM_RES_UP          PIN_DM_RES_UP
#define VDD_en_DM_RES_DWN         PIN_DM_RES_DWN
#define VDD_en_DM_OD_LO           PIN_DM_OD_LO
#define VDD_en_DM_OD_HI           PIN_DM_OD_HI
#define VDD_en_DM_STRONG          PIN_DM_STRONG
#define VDD_en_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define VDD_en_MASK               VDD_en__MASK
#define VDD_en_SHIFT              VDD_en__SHIFT
#define VDD_en_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define VDD_en_PS                     (* (reg8 *) VDD_en__PS)
/* Data Register */
#define VDD_en_DR                     (* (reg8 *) VDD_en__DR)
/* Port Number */
#define VDD_en_PRT_NUM                (* (reg8 *) VDD_en__PRT) 
/* Connect to Analog Globals */                                                  
#define VDD_en_AG                     (* (reg8 *) VDD_en__AG)                       
/* Analog MUX bux enable */
#define VDD_en_AMUX                   (* (reg8 *) VDD_en__AMUX) 
/* Bidirectional Enable */                                                        
#define VDD_en_BIE                    (* (reg8 *) VDD_en__BIE)
/* Bit-mask for Aliased Register Access */
#define VDD_en_BIT_MASK               (* (reg8 *) VDD_en__BIT_MASK)
/* Bypass Enable */
#define VDD_en_BYP                    (* (reg8 *) VDD_en__BYP)
/* Port wide control signals */                                                   
#define VDD_en_CTL                    (* (reg8 *) VDD_en__CTL)
/* Drive Modes */
#define VDD_en_DM0                    (* (reg8 *) VDD_en__DM0) 
#define VDD_en_DM1                    (* (reg8 *) VDD_en__DM1)
#define VDD_en_DM2                    (* (reg8 *) VDD_en__DM2) 
/* Input Buffer Disable Override */
#define VDD_en_INP_DIS                (* (reg8 *) VDD_en__INP_DIS)
/* LCD Common or Segment Drive */
#define VDD_en_LCD_COM_SEG            (* (reg8 *) VDD_en__LCD_COM_SEG)
/* Enable Segment LCD */
#define VDD_en_LCD_EN                 (* (reg8 *) VDD_en__LCD_EN)
/* Slew Rate Control */
#define VDD_en_SLW                    (* (reg8 *) VDD_en__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define VDD_en_PRTDSI__CAPS_SEL       (* (reg8 *) VDD_en__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define VDD_en_PRTDSI__DBL_SYNC_IN    (* (reg8 *) VDD_en__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define VDD_en_PRTDSI__OE_SEL0        (* (reg8 *) VDD_en__PRTDSI__OE_SEL0) 
#define VDD_en_PRTDSI__OE_SEL1        (* (reg8 *) VDD_en__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define VDD_en_PRTDSI__OUT_SEL0       (* (reg8 *) VDD_en__PRTDSI__OUT_SEL0) 
#define VDD_en_PRTDSI__OUT_SEL1       (* (reg8 *) VDD_en__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define VDD_en_PRTDSI__SYNC_OUT       (* (reg8 *) VDD_en__PRTDSI__SYNC_OUT) 


#if defined(VDD_en__INTSTAT)  /* Interrupt Registers */

    #define VDD_en_INTSTAT                (* (reg8 *) VDD_en__INTSTAT)
    #define VDD_en_SNAP                   (* (reg8 *) VDD_en__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins VDD_en_H */


/* [] END OF FILE */
